"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _eui = require("@elastic/eui");

/*
 * Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
var ConfirmationModal = function ConfirmationModal(_ref) {
  var title = _ref.title,
      bodyMessage = _ref.bodyMessage,
      actionMessage = _ref.actionMessage,
      onClose = _ref.onClose,
      onAction = _ref.onAction;
  return /*#__PURE__*/_react.default.createElement(_eui.EuiOverlayMask, null, /*#__PURE__*/_react.default.createElement(_eui.EuiModal, {
    onCancel: onClose,
    onClose: onClose,
    maxWidth: 1000
  }, /*#__PURE__*/_react.default.createElement(_eui.EuiModalHeader, null, /*#__PURE__*/_react.default.createElement(_eui.EuiModalHeaderTitle, null, title)), /*#__PURE__*/_react.default.createElement(_eui.EuiModalBody, null, bodyMessage), /*#__PURE__*/_react.default.createElement(_eui.EuiModalFooter, null, /*#__PURE__*/_react.default.createElement(_eui.EuiButtonEmpty, {
    onClick: onClose,
    "data-test-subj": "confirmationModalCloseButton"
  }, "Cancel"), /*#__PURE__*/_react.default.createElement(_eui.EuiButton, {
    onClick: function onClick() {
      onAction();
      onClose();
    },
    fill: true,
    "data-test-subj": "confirmationModalActionButton"
  }, actionMessage))));
};

var _default = ConfirmationModal;
exports.default = _default;
module.exports = exports.default;