"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _eui = require("@elastic/eui");

var _ContentPanel = require("../../../../../components/ContentPanel");

/*
 * Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Attempting to test EuiCodeEditor which uses react-ace was a lot more effort than seemed worthwhile
 * at the moment, so in the meantime we will mock DefinePolicy as a EuiTextArea so that we can still test
 * the functionality of CreatePolicy (minus the JSON code editor).
 * */
var DefinePolicy = function DefinePolicy(_ref) {
  var jsonString = _ref.jsonString,
      _onChange = _ref.onChange,
      onAutoIndent = _ref.onAutoIndent,
      hasJSONError = _ref.hasJSONError;
  return /*#__PURE__*/_react.default.createElement(_ContentPanel.ContentPanel, {
    bodyStyles: {
      padding: "initial"
    },
    title: "Define policy",
    titleSize: "s",
    actions: [/*#__PURE__*/_react.default.createElement(_eui.EuiCopy, {
      textToCopy: jsonString
    }, function (copy) {
      return /*#__PURE__*/_react.default.createElement(_eui.EuiButton, {
        iconType: "copyClipboard",
        onClick: copy
      }, "Copy");
    }), /*#__PURE__*/_react.default.createElement(_eui.EuiButton, {
      iconType: "editorAlignLeft",
      onClick: onAutoIndent,
      disabled: hasJSONError
    }, "Auto Indent")]
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      paddingLeft: "10px"
    }
  }, /*#__PURE__*/_react.default.createElement(_eui.EuiText, {
    size: "xs"
  }, /*#__PURE__*/_react.default.createElement("p", null, "Create a policy with a JSON configuration file. This can be added directly in the code editor below."))), /*#__PURE__*/_react.default.createElement(_eui.EuiSpacer, {
    size: "s"
  }), /*#__PURE__*/_react.default.createElement(_eui.EuiTextArea, {
    value: jsonString,
    onChange: function onChange(e) {
      return _onChange(e.target.value);
    },
    "aria-label": "Code Editor"
  }));
};

var _default = DefinePolicy;
exports.default = _default;
module.exports = exports.default;