"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.indicesColumns = exports.DEFAULT_QUERY_PARAMS = exports.DEFAULT_PAGE_SIZE_OPTIONS = void 0;

var _react = _interopRequireDefault(require("react"));

var _eui = require("@elastic/eui");

var _constants = require("../../../utils/constants");

/*
 * Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
var DEFAULT_PAGE_SIZE_OPTIONS = [5, 10, 20, 50];
exports.DEFAULT_PAGE_SIZE_OPTIONS = DEFAULT_PAGE_SIZE_OPTIONS;
var DEFAULT_QUERY_PARAMS = {
  from: 0,
  size: 20,
  search: "",
  sortField: "name",
  sortDirection: _constants.SortDirection.DESC
};
exports.DEFAULT_QUERY_PARAMS = DEFAULT_QUERY_PARAMS;
var HEALTH_TO_COLOR = {
  green: "success",
  yellow: "warning",
  red: "danger"
};
var indicesColumns = [{
  field: "index",
  name: "Index",
  sortable: true,
  truncateText: true,
  textOnly: true,
  width: "250px",
  render: function render(index) {
    return /*#__PURE__*/_react.default.createElement("span", {
      title: index
    }, index);
  }
}, {
  field: "health",
  name: "Health",
  sortable: true,
  truncateText: true,
  textOnly: true,
  align: "right",
  render: function render(health, item) {
    var color = health ? HEALTH_TO_COLOR[health] : "subdued";
    var text = health || item.status;
    return /*#__PURE__*/_react.default.createElement(_eui.EuiHealth, {
      color: color
    }, text);
  }
}, {
  field: "managed",
  name: "Managed by Policy",
  sortable: false,
  truncateText: true,
  textOnly: true,
  align: "right",
  width: "150px"
}, {
  field: "status",
  name: "Status",
  sortable: true,
  truncateText: true,
  textOnly: true,
  align: "right"
}, {
  field: "store.size",
  name: "Total size",
  sortable: true,
  truncateText: true,
  textOnly: true,
  dataType: "number"
}, {
  field: "pri.store.size",
  name: "Primaries size",
  sortable: true,
  truncateText: true,
  textOnly: true,
  dataType: "number"
}, {
  field: "docs.count",
  name: "Total documents",
  sortable: true,
  truncateText: true,
  textOnly: true,
  dataType: "number",
  render: function render(count) {
    return /*#__PURE__*/_react.default.createElement("span", {
      title: count
    }, count);
  }
}, {
  field: "docs.deleted",
  name: "Deleted documents",
  sortable: true,
  truncateText: true,
  textOnly: true,
  dataType: "number",
  render: function render(deleted) {
    return /*#__PURE__*/_react.default.createElement("span", {
      title: deleted
    }, deleted);
  }
}, {
  field: "pri",
  name: "Primaries",
  sortable: true,
  truncateText: true,
  textOnly: true,
  dataType: "number"
}, {
  field: "rep",
  name: "Replicas",
  sortable: true,
  truncateText: true,
  textOnly: true,
  dataType: "number"
}];
exports.indicesColumns = indicesColumns;