"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _constants = require("../../utils/constants");

/*
 * Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
function _default(server, services) {
  var indexService = services.indexService;
  server.route({
    path: _constants.NODE_API._SEARCH,
    method: _constants.REQUEST.POST,
    handler: indexService.search
  });
  server.route({
    path: _constants.NODE_API._INDICES,
    method: _constants.REQUEST.GET,
    handler: indexService.getIndices
  });
  server.route({
    path: _constants.NODE_API.APPLY_POLICY,
    method: _constants.REQUEST.POST,
    handler: indexService.applyPolicy
  });
  server.route({
    path: _constants.NODE_API.EDIT_ROLLOVER_ALIAS,
    method: _constants.REQUEST.POST,
    handler: indexService.editRolloverAlias
  });
}

module.exports = exports.default;