"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _constants = require("../../utils/constants");

/*
 * Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
function _default(server, services) {
  var managedIndexService = services.managedIndexService;
  server.route({
    path: _constants.NODE_API.MANAGED_INDICES,
    method: _constants.REQUEST.GET,
    handler: managedIndexService.getManagedIndices
  });
  server.route({
    path: "".concat(_constants.NODE_API.MANAGED_INDICES, "/{id}"),
    method: _constants.REQUEST.GET,
    handler: managedIndexService.getManagedIndex
  });
  server.route({
    path: _constants.NODE_API.RETRY,
    method: _constants.REQUEST.POST,
    handler: managedIndexService.retryManagedIndexPolicy
  });
  server.route({
    path: _constants.NODE_API.CHANGE_POLICY,
    method: _constants.REQUEST.POST,
    handler: managedIndexService.changePolicy
  });
  server.route({
    path: _constants.NODE_API.REMOVE_POLICY,
    method: _constants.REQUEST.POST,
    handler: managedIndexService.removePolicy
  });
}

module.exports = exports.default;