"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _constants = require("../utils/constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var IndexService = function IndexService(esDriver) {
  var _this = this;

  (0, _classCallCheck2.default)(this, IndexService);
  (0, _defineProperty2.default)(this, "esDriver", void 0);
  (0, _defineProperty2.default)(this, "search", /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(req, h) {
      var _ref2, query, index, _ref2$size, size, params, _this$esDriver$getClu, callWithRequest, results;

      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _ref2 = req.payload, query = _ref2.query, index = _ref2.index, _ref2$size = _ref2.size, size = _ref2$size === void 0 ? 0 : _ref2$size;
              params = {
                index: index,
                size: size,
                body: query
              };
              _this$esDriver$getClu = _this.esDriver.getCluster(_constants.CLUSTER.DATA), callWithRequest = _this$esDriver$getClu.callWithRequest;
              _context.next = 6;
              return callWithRequest(req, "search", params);

            case 6:
              results = _context.sent;
              return _context.abrupt("return", {
                ok: true,
                response: results
              });

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](0);
              console.error("Index Management - IndexService - search", _context.t0);
              return _context.abrupt("return", {
                ok: false,
                error: _context.t0.message
              });

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 10]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "getIndices", /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(req, h) {
      var _ref4, from, size, search, sortField, sortDirection, params, _this$esDriver$getClu2, callWithRequest, indicesResponse, fromNumber, sizeNumber, paginatedIndices, indexUuids, managedStatus;

      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              // @ts-ignore
              _ref4 = req.query, from = _ref4.from, size = _ref4.size, search = _ref4.search, sortField = _ref4.sortField, sortDirection = _ref4.sortDirection;
              params = {
                index: "*".concat(search.trim().split(" ").join("* *"), "*"),
                format: "json",
                s: "".concat(sortField, ":").concat(sortDirection)
              };
              _this$esDriver$getClu2 = _this.esDriver.getCluster(_constants.CLUSTER.DATA), callWithRequest = _this$esDriver$getClu2.callWithRequest;
              _context2.next = 6;
              return callWithRequest(req, "cat.indices", params);

            case 6:
              indicesResponse = _context2.sent;
              // _cat doesn't support pagination, do our own in server pagination to at least reduce network bandwidth
              fromNumber = parseInt(from, 10);
              sizeNumber = parseInt(size, 10);
              paginatedIndices = indicesResponse.slice(fromNumber, fromNumber + sizeNumber);
              indexUuids = paginatedIndices.map(function (value) {
                return value.uuid;
              });
              _context2.next = 13;
              return _this._getManagedStatus(req, indexUuids);

            case 13:
              managedStatus = _context2.sent;
              return _context2.abrupt("return", {
                ok: true,
                response: {
                  indices: paginatedIndices.map(function (catIndex) {
                    return _objectSpread({}, catIndex, {
                      managed: managedStatus[catIndex.uuid] || "N/A"
                    });
                  }),
                  totalIndices: indicesResponse.length
                }
              });

            case 17:
              _context2.prev = 17;
              _context2.t0 = _context2["catch"](0);

              if (!(_context2.t0.statusCode === 404 && _context2.t0.body.error.type === "index_not_found_exception")) {
                _context2.next = 21;
                break;
              }

              return _context2.abrupt("return", {
                ok: true,
                response: {
                  indices: [],
                  totalIndices: 0
                }
              });

            case 21:
              console.error("Index Management - IndexService - getIndices:", _context2.t0);
              return _context2.abrupt("return", {
                ok: false,
                error: _context2.t0.message
              });

            case 23:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[0, 17]]);
    }));

    return function (_x3, _x4) {
      return _ref3.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "_getManagedStatus", /*#__PURE__*/function () {
    var _ref5 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3(req, indexUuids) {
      var searchParams, _this$esDriver$getClu3, searchCallWithRequest, results, managed;

      return _regenerator.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              searchParams = {
                index: _constants.INDEX.OPENDISTRO_ISM_CONFIG,
                size: indexUuids.length,
                body: {
                  _source: "_id",
                  query: {
                    ids: {
                      values: indexUuids
                    }
                  }
                }
              };
              _this$esDriver$getClu3 = _this.esDriver.getCluster(_constants.CLUSTER.DATA), searchCallWithRequest = _this$esDriver$getClu3.callWithRequest;
              _context3.next = 5;
              return searchCallWithRequest(req, "search", searchParams);

            case 5:
              results = _context3.sent;
              managed = results.hits.hits.reduce(function (accu, hit) {
                return _objectSpread({}, accu, (0, _defineProperty2.default)({}, hit._id, "Yes"));
              }, {});
              return _context3.abrupt("return", indexUuids.reduce(function (accu, value) {
                return _objectSpread({}, accu, (0, _defineProperty2.default)({}, value, managed[value] || "No"));
              }, {}));

            case 10:
              _context3.prev = 10;
              _context3.t0 = _context3["catch"](0);

              if (!(_context3.t0.statusCode === 404 && _context3.t0.body.error.type === "index_not_found_exception")) {
                _context3.next = 14;
                break;
              }

              return _context3.abrupt("return", indexUuids.reduce(function (accu, value) {
                return _objectSpread({}, accu, (0, _defineProperty2.default)({}, value, "No"));
              }, {}));

            case 14:
              // otherwise it could be an unauthorized access error to config index or some other error
              // in which case we will return managed status N/A
              console.error("Index Management - IndexService - _getManagedStatus:", _context3.t0);
              return _context3.abrupt("return", indexUuids.reduce(function (accu, value) {
                return _objectSpread({}, accu, (0, _defineProperty2.default)({}, value, "N/A"));
              }, {}));

            case 16:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[0, 10]]);
    }));

    return function (_x5, _x6) {
      return _ref5.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "applyPolicy", /*#__PURE__*/function () {
    var _ref6 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee4(req, h) {
      var _ref7, indices, policyId, _yield$_this$esDriver, callWithRequest, params, addResponse;

      return _regenerator.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.prev = 0;
              _ref7 = req.payload, indices = _ref7.indices, policyId = _ref7.policyId;
              _context4.next = 4;
              return _this.esDriver.getCluster(_constants.CLUSTER.ISM);

            case 4:
              _yield$_this$esDriver = _context4.sent;
              callWithRequest = _yield$_this$esDriver.callWithRequest;
              params = {
                index: indices.join(","),
                body: {
                  policy_id: policyId
                }
              };
              _context4.next = 9;
              return callWithRequest(req, "ism.add", params);

            case 9:
              addResponse = _context4.sent;
              return _context4.abrupt("return", {
                ok: true,
                response: {
                  failures: addResponse.failures,
                  updatedIndices: addResponse.updated_indices,
                  failedIndices: addResponse.failed_indices.map(function (failedIndex) {
                    return {
                      indexName: failedIndex.index_name,
                      indexUuid: failedIndex.index_uuid,
                      reason: failedIndex.reason
                    };
                  })
                }
              });

            case 13:
              _context4.prev = 13;
              _context4.t0 = _context4["catch"](0);
              console.error("Index Management - IndexService - applyPolicy:", _context4.t0);
              return _context4.abrupt("return", {
                ok: false,
                error: _context4.t0.message
              });

            case 17:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[0, 13]]);
    }));

    return function (_x7, _x8) {
      return _ref6.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "editRolloverAlias", /*#__PURE__*/function () {
    var _ref8 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee5(req, h) {
      var _ref9, alias, index, _yield$_this$esDriver2, callWithRequest, params, response;

      return _regenerator.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.prev = 0;
              _ref9 = req.payload, alias = _ref9.alias, index = _ref9.index;
              _context5.next = 4;
              return _this.esDriver.getCluster(_constants.CLUSTER.DATA);

            case 4:
              _yield$_this$esDriver2 = _context5.sent;
              callWithRequest = _yield$_this$esDriver2.callWithRequest;
              params = {
                index: index,
                body: (0, _defineProperty2.default)({}, _constants.Setting.RolloverAlias, alias)
              };
              _context5.next = 9;
              return callWithRequest(req, "indices.putSettings", params);

            case 9:
              response = _context5.sent;
              return _context5.abrupt("return", {
                ok: true,
                response: response
              });

            case 13:
              _context5.prev = 13;
              _context5.t0 = _context5["catch"](0);
              console.error("Index Management - IndexService - editRolloverAlias", _context5.t0);
              return _context5.abrupt("return", {
                ok: false,
                error: _context5.t0.message
              });

            case 17:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[0, 13]]);
    }));

    return function (_x9, _x10) {
      return _ref8.apply(this, arguments);
    };
  }());
  this.esDriver = esDriver;
};

exports.default = IndexService;
module.exports = exports.default;