declare module '@elastic/eui/dist/eui_theme_dark.json' {
  const sassVariables: {
    paddingSizes: {
      xs: string;
      s: string;
      m: string;
      l: string;
      xl: string;
    };
    avatarSizing: {
      s: {
        size: string;
        'font-size': string;
      };
      m: {
        size: string;
        'font-size': string;
      };
      l: {
        size: string;
        'font-size': string;
      };
      xl: {
        size: string;
        'font-size': string;
      };
    };
    badgeTypes: {
      default: string;
      primary: string;
      secondary: string;
      warning: string;
      danger: string;
      accent: string;
    };
    euiBreadcrumbSpacing: string;
    euiBreadcrumbTruncateWidth: string;
    euiBreadcrumbMinWidth: string;
    buttonTypes: {
      primary: string;
      secondary: string;
      warning: string;
      danger: string;
      ghost: string;
      text: string;
    };
    euiButtonHeight: string;
    euiButtonHeightSmall: string;
    euiButtonColorDisabled: string;
    euiButtonToggleBorderColor: string;
    euiCallOutTypes: {
      primary: string;
      success: string;
      warning: string;
      danger: string;
    };
    callOutTypes: {
      primary: string;
      success: string;
      warning: string;
      danger: string;
    };
    euiCardSpacing: string;
    euiCardTitleSize: string;
    euiCardGraphicHeight: string;
    euiCardSelectButtonBorders: {
      text: string;
      primary: string;
      success: string;
      danger: string;
      ghost: string;
    };
    euiCardSelectButtonBackgrounds: {
      text: string;
      primary: string;
      success: string;
      danger: string;
      ghost: string;
    };
    euiColorPickerValueRange0: string;
    euiColorPickerValueRange1: string;
    euiColorPickerSaturationRange0: string;
    euiColorPickerSaturationRange1: string;
    euiColorPickerIndicatorSize: string;
    euiContextMenuWidth: string;
    euiDatePickerCalendarWidth: string;
    euiSuperDatePickerWidth: string;
    euiSuperDatePickerButtonWidth: string;
    euiDragAndDropSpacing: {
      s: string;
      m: string;
      l: string;
    };
    euiExpressionColors: {
      subdued: string;
      primary: string;
      secondary: string;
      warning: string;
      danger: string;
      accent: string;
    };
    gutterTypes: {
      gutterExtraSmall: string;
      gutterSmall: string;
      gutterMedium: string;
      gutterLarge: string;
      gutterExtraLarge: string;
    };
    fractions: {
      fourths: {
        percentage: string;
        count: number;
      };
      thirds: {
        percentage: string;
        count: number;
      };
      halves: {
        percentage: string;
        count: number;
      };
      single: {
        percentage: string;
        count: number;
      };
    };
    flyoutSizes: {
      small: {
        min: string;
        width: string;
        max: string;
      };
      medium: {
        min: string;
        width: string;
        max: string;
      };
      large: {
        min: string;
        width: string;
        max: string;
      };
    };
    euiFormMaxWidth: string;
    euiFormControlHeight: string;
    euiFormControlCompressedHeight: string;
    euiFormControlPadding: string;
    euiFormControlCompressedPadding: string;
    euiRadioSize: string;
    euiCheckBoxSize: string;
    euiSwitchHeight: string;
    euiSwitchWidth: string;
    euiSwitchThumbSize: string;
    euiSwitchIconHeight: string;
    euiFormBackgroundColor: string;
    euiFormBackgroundDisabledColor: string;
    euiFormBorderColor: string;
    euiFormBorderDisabledColor: string;
    euiFormCustomControlDisabledIconColor: string;
    euiFormControlDisabledColor: string;
    euiFormControlBoxShadow: string;
    euiFormInputGroupLabelBackground: string;
    euiRangeLevelColors: {
      primary: string;
      success: string;
      warning: string;
      danger: string;
    };
    euiRangeTrackColor: string;
    euiRangeThumbRadius: string;
    euiRangeThumbHeight: string;
    euiRangeThumbWidth: string;
    euiRangeThumbBorderColor: string;
    euiRangeTrackWidth: string;
    euiRangeTrackHeight: string;
    euiRangeTrackBorderWidth: number;
    euiRangeTrackBorderColor: string;
    euiRangeTrackRadius: string;
    euiRangeDisabledOpacity: number;
    textareaResizing: {
      vertical: string;
      horizontal: string;
      both: string;
      none: string;
    };
    euiHeaderBackgroundColor: string;
    euiHeaderBreadcrumbColor: string;
    euiHeaderChildSize: string;
    ruleMargins: {
      marginXSmall: string;
      marginSmall: string;
      marginMedium: string;
      marginLarge: string;
      marginXLarge: string;
      marginXXLarge: string;
    };
    euiIconLoadingOpacity: number;
    euiIconColors: {
      text: string;
      primary: string;
      subdued: string;
      secondary: string;
      success: string;
      accent: string;
      warning: string;
      danger: string;
      ghost: string;
    };
    euiIconSizes: {
      small: string;
      medium: string;
      large: string;
      xLarge: string;
      xxLarge: string;
    };
    euiKeyPadMenuSize: string;
    textColors: {
      default: string;
      subdued: string;
      secondary: string;
      accent: string;
      warning: string;
      danger: string;
      ghost: string;
    };
    euiGradientStartStop: string;
    euiGradientMiddle: string;
    euiNavDrawerBackgroundColor: string;
    euiNavDrawerWidthExpanded: string;
    euiNavDrawerWidthCollapsed: string;
    euiNavDrawerSideShadow: string;
    euiNavDrawerTopPosition: string;
    euiNavDrawerExpandingDelay: string;
    euiNavDrawerContractingDelay: string;
    euiNavDrawerExtendedDelay: string;
    euiNavDrawerMenuAddedDelay: string;
    euiPanelPaddingModifiers: {
      paddingSmall: string;
      paddingMedium: string;
      paddingLarge: string;
    };
    euiPanelBorderColor: string;
    euiPopoverArrowSize: string;
    euiPopoverTranslateDistance: string;
    euiProgressSizes: {
      xs: string;
      s: string;
      m: string;
      l: string;
    };
    euiProgressColors: {
      primary: string;
      secondary: string;
      warning: string;
      danger: string;
      accent: string;
      subdued: string;
    };
    euiSelectableListItemBorder: string;
    spacerSizes: {
      xs: string;
      s: string;
      m: string;
      l: string;
      xl: string;
      xxl: string;
    };
    euiStepNumberSize: string;
    euiStepNumberMargin: string;
    euiStepStatusColorsToFade: {
      warning: string;
      danger: string;
      disabled: string;
      incomplete: string;
    };
    euiTableCellContentPadding: string;
    euiTableCellContentPaddingCompressed: string;
    euiTableCellCheckboxWidth: string;
    euiTableActionsAreaWidth: string;
    euiTableHoverColor: string;
    euiTableSelectedColor: string;
    euiTableHoverSelectedColor: string;
    euiTableActionsBorderColor: string;
    euiTableHoverClickableColor: string;
    euiTableFocusClickableColor: string;
    euiTabFontSize: string;
    euiTabFontSizeS: string;
    euiTextConstrainedMaxWidth: string;
    euiToastWidth: string;
    toastTypes: {
      primary: string;
      success: string;
      warning: string;
      danger: string;
    };
    tokenTypes: {
      tokenTint01: string;
      tokenTint02: string;
      tokenTint03: string;
      tokenTint04: string;
      tokenTint05: string;
      tokenTint06: string;
      tokenTint07: string;
      tokenTint08: string;
      tokenTint09: string;
      tokenTint10: string;
      tokenTint11: string;
      tokenTint12: string;
    };
    euiTooltipBackgroundColor: string;
    euiTooltipAnimations: {
      top: string;
      left: string;
      bottom: string;
      right: string;
    };
    euiFocusRingColor: string;
    euiFocusRingAnimStartColor: string;
    euiFocusRingSize: string;
    euiFocusRingSizeLarge: string;
    euiAnimSlightBounce: string;
    euiAnimSlightResistance: string;
    euiAnimSpeedExtraFast: string;
    euiAnimSpeedFast: string;
    euiAnimSpeedNormal: string;
    euiAnimSpeedSlow: string;
    euiAnimSpeedExtraSlow: string;
    euiBorderWidthThin: string;
    euiBorderWidthThick: string;
    euiBorderColor: string;
    euiBorderRadius: string;
    euiBorderThick: string;
    euiBorderThin: string;
    euiBorderEditable: string;
    euiColorPrimary: string;
    euiColorSecondary: string;
    euiColorAccent: string;
    euiColorHighlight: string;
    euiColorGhost: string;
    euiColorInk: string;
    euiColorSuccess: string;
    euiColorDanger: string;
    euiColorWarning: string;
    euiColorEmptyShade: string;
    euiColorLightestShade: string;
    euiColorLightShade: string;
    euiColorMediumShade: string;
    euiColorDarkShade: string;
    euiColorDarkestShade: string;
    euiColorFullShade: string;
    euiTextColor: string;
    euiTitleColor: string;
    euiLinkColor: string;
    euiFocusBackgroundColor: string;
    euiPageBackgroundColor: string;
    euiColorVis0: string;
    euiColorVis1: string;
    euiColorVis2: string;
    euiColorVis3: string;
    euiColorVis4: string;
    euiColorVis5: string;
    euiColorVis6: string;
    euiColorVis7: string;
    euiColorVis8: string;
    euiColorVis9: string;
    euiCodeBlockBackgroundColor: string;
    euiCodeBlockColor: string;
    euiCodeBlockSelectedBackgroundColor: string;
    euiCodeBlockCommentColor: string;
    euiCodeBlockSelectorTagColor: string;
    euiCodeBlockStringColor: string;
    euiCodeBlockNumberColor: string;
    euiCodeBlockKeywordColor: string;
    euiCodeBlockFunctionTitleColor: string;
    euiCodeBlockTagColor: string;
    euiCodeBlockNameColor: string;
    euiCodeBlockTypeColor: string;
    euiCodeBlockAttributeColor: string;
    euiCodeBlockSymbolColor: string;
    euiCodeBlockParamsColor: string;
    euiCodeBlockMetaColor: string;
    euiCodeBlockTitleColor: string;
    euiCodeBlockRegexpColor: string;
    euiCodeBlockBuiltInColor: string;
    euiCodeBlockSectionColor: string;
    euiCodeBlockAdditionBackgroundColor: string;
    euiCodeBlockAdditionColor: string;
    euiCodeBlockDeletionBackgroundColor: string;
    euiCodeBlockDeletionColor: string;
    euiCodeBlockSelectorClassColor: string;
    euiCodeBlockSelectorIdColor: string;
    euiBreakpoints: {
      xs: number;
      s: string;
      m: string;
      l: string;
      xl: string;
    };
    euiBreakpointKeys: string;
    euiShadowColor: string;
    euiShadowColorLarge: string;
    euiSize: string;
    euiSizeXS: string;
    euiSizeS: string;
    euiSizeM: string;
    euiSizeL: string;
    euiSizeXL: string;
    euiSizeXXL: string;
    euiButtonMinWidth: string;
    euiScrollBar: string;
    euiScrollBarCorner: string;
    euiFontFamily: string;
    euiCodeFontFamily: string;
    euiFontFeatureSettings: string;
    euiTextScale: string;
    euiFontSize: string;
    euiFontSizeXS: string;
    euiFontSizeS: string;
    euiFontSizeM: string;
    euiFontSizeL: string;
    euiFontSizeXL: string;
    euiFontSizeXXL: string;
    euiLineHeight: number;
    euiFontWeightLight: number;
    euiFontWeightRegular: number;
    euiFontWeightMedium: number;
    euiFontWeightSemiBold: number;
    euiFontWeightBold: number;
    euiZLevel0: number;
    euiZLevel1: number;
    euiZLevel2: number;
    euiZLevel3: number;
    euiZLevel4: number;
    euiZLevel5: number;
    euiZLevel6: number;
    euiZLevel7: number;
    euiZLevel8: number;
    euiZLevel9: number;
    euiZContent: number;
    euiZHeader: number;
    euiZContentMenu: number;
    euiZNavigation: number;
    euiZMask: number;
    euiZModal: number;
    euiZComboBox: number;
    euiZToastList: number;
  };
  export default sassVariables;
}
