import React from 'react';
import { render } from 'enzyme';
import { requiredProps, startThrowingReactWarnings, stopThrowingReactWarnings } from '../../test';
import { EuiFlexItem, GROW_SIZES } from './flex_item';
beforeAll(startThrowingReactWarnings);
afterAll(stopThrowingReactWarnings);
describe('EuiFlexItem', function () {
  test('is rendered', function () {
    var component = render(React.createElement(EuiFlexItem, requiredProps));
    expect(component).toMatchSnapshot();
  });
  describe('grow', function () {
    GROW_SIZES.concat([true, false]).forEach(function (value) {
      test("".concat(value, " is rendered"), function () {
        var component = render(React.createElement(EuiFlexItem, {
          grow: value
        }));
        expect(component).toMatchSnapshot();
      });
    });
  });
  describe('component', function () {
    ['div', 'span', 'figure'].forEach(function (value) {
      test("".concat(value, " is rendered"), function () {
        var component = render(React.createElement(EuiFlexItem, {
          component: value
        }));
        expect(component).toMatchSnapshot();
      });
    });
    ['h2'].forEach(function (value) {
      test("".concat(value, " is not rendered"), function () {
        expect(function () {
          return render( // intentionally passing an invalid value
          // @ts-ignore
          React.createElement(EuiFlexItem, {
            component: value
          }));
        }).toThrow();
      });
    });
  });
});