"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiDefaultAxis = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _x_axis = require("./x_axis");

var _y_axis = require("./y_axis");

var _horizontal_grid = require("./horizontal_grid");

var _vertical_grid = require("./vertical_grid");

var _chart_utils = require("../utils/chart_utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * The Default Axis component, with X and Y axis on the bottom and left position respectively,
 * and horiznontal or vertical grid depending on the orientation prop.
 */
var EuiDefaultAxis =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(EuiDefaultAxis, _PureComponent);

  function EuiDefaultAxis() {
    _classCallCheck(this, EuiDefaultAxis);

    return _possibleConstructorReturn(this, _getPrototypeOf(EuiDefaultAxis).apply(this, arguments));
  }

  _createClass(EuiDefaultAxis, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          showGridLines = _this$props.showGridLines,
          orientation = _this$props.orientation,
          xOnZero = _this$props.xOnZero,
          yOnZero = _this$props.yOnZero,
          rest = _objectWithoutProperties(_this$props, ["showGridLines", "orientation", "xOnZero", "yOnZero"]);

      return _react.default.createElement(_react.Fragment, null, showGridLines && orientation === _chart_utils.ORIENTATION.VERTICAL && _react.default.createElement(_horizontal_grid.EuiHorizontalGrid, rest), showGridLines && orientation === _chart_utils.ORIENTATION.HORIZONTAL && _react.default.createElement(_vertical_grid.EuiVerticalGrid, rest), _react.default.createElement(_x_axis.EuiXAxis, _extends({
        onZero: xOnZero
      }, rest)), _react.default.createElement(_y_axis.EuiYAxis, _extends({
        onZero: yOnZero
      }, rest)));
    }
  }]);

  return EuiDefaultAxis;
}(_react.PureComponent);

exports.EuiDefaultAxis = EuiDefaultAxis;
EuiDefaultAxis.displayName = 'EuiDefaultAxis';
EuiDefaultAxis.propTypes = {
  /** The orientation of the chart, used to determine the correct orientation of grids */
  orientation: _propTypes.default.string,

  /** Show/Hide the background grids */
  showGridLines: _propTypes.default.bool,

  /** Specify if the x axis lay on 0, otherwise lyed on min x */
  xOnZero: _propTypes.default.bool,

  /** Specify if the y axis lay on 0, otherwise layd on min y */
  yOnZero: _propTypes.default.bool
};
EuiDefaultAxis.defaultProps = {
  orientation: _chart_utils.ORIENTATION.VERTICAL,
  showGridLines: true,
  xOnZero: false,
  yOnZero: false
};
EuiDefaultAxis.requiresSVG = true;
EuiDefaultAxis.__docgenInfo = {
  "description": "The Default Axis component, with X and Y axis on the bottom and left position respectively,\nand horiznontal or vertical grid depending on the orientation prop.",
  "methods": [],
  "displayName": "EuiDefaultAxis",
  "props": {
    "orientation": {
      "defaultValue": {
        "value": "ORIENTATION.VERTICAL",
        "computed": true
      },
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "The orientation of the chart, used to determine the correct orientation of grids"
    },
    "showGridLines": {
      "defaultValue": {
        "value": "true",
        "computed": false
      },
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Show/Hide the background grids"
    },
    "xOnZero": {
      "defaultValue": {
        "value": "false",
        "computed": false
      },
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Specify if the x axis lay on 0, otherwise lyed on min x"
    },
    "yOnZero": {
      "defaultValue": {
        "value": "false",
        "computed": false
      },
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Specify if the y axis lay on 0, otherwise layd on min y"
    }
  }
};