"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeFlexible = makeFlexible;

var _react = _interopRequireWildcard(require("react"));

var _resizeObserverPolyfill = _interopRequireDefault(require("resize-observer-polyfill"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function makeFlexible(WrappedComponent) {
  return (
    /*#__PURE__*/
    function (_PureComponent) {
      _inherits(FlexibleEuiSeriesChart, _PureComponent);

      function FlexibleEuiSeriesChart(props) {
        var _this;

        _classCallCheck(this, FlexibleEuiSeriesChart);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(FlexibleEuiSeriesChart).call(this, props));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onResize", function (entries) {
          entries.forEach(function (entry) {
            var _entry$contentRect = entry.contentRect,
                width = _entry$contentRect.width,
                height = _entry$contentRect.height;
            var notifyWidth = _this.state.width !== width;
            var notifyHeight = _this.state.height !== height;

            if (notifyWidth || notifyHeight) {
              _this.setState({
                width: width,
                height: height
              });
            }
          });
        });

        _this.state = {
          height: 0,
          width: 0
        };
        _this.containerRef = _react.default.createRef();
        _this.ro = new _resizeObserverPolyfill.default(_this.onResize);
        return _this;
      }

      _createClass(FlexibleEuiSeriesChart, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          this.ro.observe(this.containerRef.current);
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.ro.unobserve(this.containerRef.current);
        }
      }, {
        key: "render",
        value: function render() {
          return _react.default.createElement("div", {
            ref: this.containerRef,
            style: {
              width: '100%',
              height: '100%'
            }
          }, _react.default.createElement(WrappedComponent, _extends({}, this.state, this.props)));
        }
      }]);

      return FlexibleEuiSeriesChart;
    }(_react.PureComponent)
  );
}